//------------------------------------------------------------------------------
//Delphi XE10.2 FireDAC Connection
//PostgreSQL9.x
//------------------------------------------------------------------------------
unit FD_Oracle_Express_21c_b_Unit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.PG,
  FireDAC.VCLUI.Wait, FireDAC.Stan.Param, FireDAC.DatS, FireDAC.DApt.Intf,
  FireDAC.DApt, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, Data.DB,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client, FireDAC.Comp.UI, FireDAC.Phys.PGDef,
  FireDAC.Phys.Oracle, FireDAC.Phys.OracleDef;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    FDConnection1: TFDConnection;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    FDQuery1: TFDQuery;
    Panel1: TPanel;
    LabeledEdit7: TLabeledEdit;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Edit_Files: TEdit;
    OpenDialog1: TOpenDialog;
    Edit_TS_NO: TEdit;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton8: TSpeedButton;
    FDPhysOracleDriverLink1: TFDPhysOracleDriverLink;
    Panel5: TPanel;
    Panel3: TPanel;
    Image2: TImage;
    Panel2: TPanel;
    Image1: TImage;
    Panel6: TPanel;
    SpeedButton9: TSpeedButton;
    Edit_Files_PDF: TEdit;
    Edit_TS_NO_2: TEdit;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses ShellAPI, JPEG, GIFImg, PNGImage ;  //gp摜

procedure TForm1.SpeedButton10Click(Sender: TObject);
var
  SQLstmt:String;
begin
  with FDConnection1 do
  try
    SQLstmt :=' INSERT INTO '
             +' test_tbl ( ts_no  , tsblob ) '
             +'	VALUES ('
             +' :ts_no , :tsblob '
             + ')';
    FDQuery1.SQL.Clear;
    FDQuery1.SQL.Text:= sqlstmt;
    FDQuery1.ParamByName('ts_no').AsInteger:=StrToInt( Edit_TS_NO_2.Text );
    FDQuery1.ParamByName('tsblob').LoadFromFile( Edit_Files_PDF.Text ,ftBlob);
    FDQuery1.ExecSQL();
    ShowMessage('o^܂');
  finally
    FDQuery1.Close;
  end;
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
var
  SQLstmt:String;
begin
  with FDConnection1 do
  try
    SQLstmt := 'SELECT * FROM test_tbl '
            +  'WHERE ts_no = :ts_no';
    FDQuery1.SQL.Clear;
    FDQuery1.SQL.Text:= sqlstmt;
    FDQuery1.ParamByName('ts_no').AsInteger:=StrToInt(Edit_TS_NO_2.Text);
    FDQuery1.Open();
    if not FDQuery1.Eof then
    begin
      Edit_TS_NO_2.Text  :=IntToStr(FDQuery1.FieldByName('ts_no').AsInteger);
      TBLOBField(FDQuery1.FieldByName('tsblob') ).SaveToFile(GetCurrentDir+'\'+'tmp_1.pdf' );
    end;
  finally
    FDQuery1.Close;
  end;
end;

procedure TForm1.SpeedButton12Click(Sender: TObject);
var
  LExeName : String;
  LUrl     : String;
begin
  LExeName := 'chrome.exe';
  LUrl     := 'file:/'+GetCurrentDir+'\'+'tmp_1.pdf';
  ShellExecute(Handle, 'open', PChar(LExeName), PChar(LUrl), nil, SW_SHOW);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  FDConnection1.Params.Values['Server']      :=LabeledEdit1.Text;
  FDConnection1.Params.Values['Database']    :=LabeledEdit2.Text;
  FDConnection1.Params.Values['User_Name']   :=LabeledEdit3.Text;
  FDConnection1.Params.Values['Password']    :=LabeledEdit4.Text;
  FDConnection1.Params.Values['CharacterSet']:=LabeledEdit5.Text;
  FDPhysOracleDriverLink1.VendorLib          :=GetCurrentDir+'\'+LabeledEdit6.Text;
  FDConnection1.Params.Values['Port']        :=LabeledEdit7.Text;

  FDConnection1.Connected:=True;
  if FDConnection1.Connected=True  then Label1.Caption:='Connect Success'
  else                                  Label1.Caption:='Not connected';
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var
  sqlstmt:string;
begin
  //PostgreSQLł́Aۂ̃f[^x[Xł́A@e[uƃtB[h́AƂȂ܂
  sqlstmt:='CREATE TABLE TEST_TBL ('+
//  'ID         serial,'+
  'TS_NO      INTEGER  not null,'+
  'TS_NAME    VARCHAR2(60) ,'+        //TEXT ,'+
  'TS_QTY     NUMBER(14,2) Default 0  ,'+    //DECIMAL(14,2) Default 0 ,'+
  'TSBLOB     BLOB ,'+
  'primary key(TS_NO)'+
  ')';
  if FDConnection1.Connected=true then
  begin
    try
      FDQuery1.SQL.Clear;
      FDQuery1.SQL.Add(sqlstmt);
      FDQuery1.ExecSQL();
      ShowMessage('CREATE TABLE');
    except
      on E: EFDDBEngineException do
      ShowMessage(E.ClassName+' error raised, with message : '+E.Message);
    end;
  end
  else ShowMessage('ERR  already exists table ');
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
  sqlstmt:string;
begin
  sqlstmt:='DROP TABLE TEST_TBL ';
  if FDConnection1.Connected=true then
  begin
    try
      FDQuery1.SQL.Clear;
      FDQuery1.SQL.Add(sqlstmt);
      FDQuery1.ExecSQL();
      ShowMessage('DROP TABLE');
    except
      on E: EFDDBEngineException do
      ShowMessage(E.ClassName+' error raised, with message : '+E.Message);
    end;
  end
  else ShowMessage('Err DROP');
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  Image2.Align:=alClient;
  Image2.Proportional:=True;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Edit_Files_PDF.Text:=OpenDialog1.FileName;
  end;
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
var
  SQLstmt:String;
begin
  with FDConnection1 do
  try
    SQLstmt :=' INSERT INTO '
             +' test_tbl ( ts_no  , tsblob ) '
             +'	VALUES ('
             +' :ts_no , :tsblob '
             + ')';
    FDQuery1.SQL.Clear;
    FDQuery1.SQL.Text:= sqlstmt;
    FDQuery1.ParamByName('ts_no').AsInteger:=StrToInt( Edit_TS_NO.Text );
    FDQuery1.ParamByName('tsblob').LoadFromFile( Edit_Files.Text ,ftBlob);
    FDQuery1.ExecSQL();
    ShowMessage('o^܂');
  finally
    FDQuery1.Close;
  end;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
var
  SQLstmt:String;
begin
  with FDConnection1 do
  try
    SQLstmt := 'SELECT * FROM test_tbl '
            +  'WHERE ts_no = :ts_no';
    FDQuery1.SQL.Clear;
    FDQuery1.SQL.Text:= sqlstmt;
    FDQuery1.ParamByName('ts_no').AsInteger:=StrToInt(Edit_ts_no.Text);
    FDQuery1.Open();
    if not FDQuery1.Eof then
    begin
      Edit_ts_no.Text  :=IntToStr(FDQuery1.FieldByName('ts_no').AsInteger);
      Image1.Picture.Assign( TBLOBField(FDQuery1.FieldByName('tsblob') ) );
    end;
  finally
    FDQuery1.Close;
  end;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  Image2.Picture:=Image1.Picture;
end;

end.
